/*

   $Id: libraw.h,v 1.6 2005/03/24 06:12:15 dmg Exp $

   Library to deal with endianism

 * Copyright (C) 2004 Daniel M. German
 *
 * Author: Daniel M. German dmg _at_ turingmachine _dot_ org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __LIBRAW_H__

#define __LIBRAW_H__

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define LITTLE_ENDIAN_ENCODING      0x4949


typedef union {
   unsigned char  bytes[2];
   u_int16_t value;
} int2;

typedef union {
   unsigned char  bytes[4];
   u_int32_t       value;
} int4;

typedef union {
   unsigned char bytes[4];
} float4;

enum byte_order_enum { big_endian, little_endian, unchanged};

typedef enum byte_order_enum byte_order;

#ifdef __cplusplus
extern "C" {
#endif
    void My_Die(char *message);

 int Convert_Number_4_bytes(int4 value, byte_order endianism);

    int Convert_Number_2_bytes(int2 value, byte_order endianism);
    float Convert_Number_Float4(float4 value, byte_order endianism);

    int Read_Int_2(FILE *file, byte_order endianism) ;
    int Read_Int_4(FILE *file, byte_order endianism) ;


    void Print_Int4(void *buffer, int length, byte_order endianism);
    void Print_Int2(void *buffer, int length, byte_order endianism);
    void Print_Bytes(unsigned char *buffer, int length);

    byte_order Host_Endianism(void);

   int Fix_Endianism_In_Record(void *record, char* recordSpec, int length, byte_order byteOrder);



#ifdef __cplusplus
}

#endif


   
#define ERROR_OUTPUT  stdout

extern int debug ;




#endif
